$(document).ready(function($) {
	if($( window ).width() < 1400)
	{
		$( "#subsection_container" ).attr("id","subsection_container_inline");
		$( "#subsection" ).attr("id","subsection_inline");
	}
	
	$('#accordion').find('.accordion-toggle').click(function(){
		
		if ($(this).attr("id")!=null && $(this).attr("id").indexOf("_link") > 0)  // check to see if it's a +/- expander
		{
			$(this).next().next().slideToggle(50); // assumes current HTML structure -- beware!
			var divId = $(this).attr("id").substring(0, $(this).attr("id").length - '_link'.length);
			if (divId != null)
			{
				var imageElement = document.getElementById(divId + "_img");	
				imageElement.src = (imageElement.src.indexOf('plus.gif') >= 0) ? imageElement.src.replace('plus.gif', 'minus.gif') : imageElement.src.replace('minus.gif', 'plus.gif');
			}
		}
		else
		{
			// assumes current HTML structure -- beware!
			if (this.previousSibling !==null)
			{
				var divId = $(this).prev().attr("id").substring(0, $(this).prev().attr("id").length - '_link'.length);
				if (divId != null)
				{
					var imageElement = document.getElementById(divId + "_img");	
					imageElement.src = (imageElement.src.indexOf('plus.gif') >= 0) ? imageElement.src.replace('plus.gif', 'minus.gif') : imageElement.src.replace('minus.gif', 'plus.gif');
				}
			}
			$(this).next().slideToggle(50);
		}
	});
	
	var constFalse = constFunc(false);

	// add onclick handler for all tabElements
	var tabs = document.getElementsByClassName("tabElement");
	for (var i = 0; i < tabs.length; ++i) {
		var tab = tabs[i];
		tab.onclick = showCurrentTab;

		// prevent child anchors from modifying page's url
		var anchors = tab.getElementsByTagName("a");
		for (var j = 0; j < anchors.length; ++j) {
			anchors.onclick = constFalse;
		}
	}
	
	let loc = window.location.toString();
	if (loc.lastIndexOf("#")>0)
	{
		//remove the page target from the location string
		loc = loc.substr(0,loc.lastIndexOf("#"));
	}
	let target = loc.substr(loc.lastIndexOf("/") + 1);
	
	
	// search for elements within the accordion element
	var $element = $("#accordion a[href*='"+target+"']");
	
	// if there are no matches or multiple matches, it probably means we're in an API Ref file
	// in that case, search the directory structure and figure out which API Ref
	// then set it to the page that's linked in the sidebar, which are hardcoded below
	if ($element.length !== 1)
	{
		if (loc.indexOf("typedoc")>0)
		{
			$element = $("#accordion a[href*='typedoc/modules/communicator.html']").last();
		}
		else if (loc.indexOf("libconverter")>0)
		{
			$element = $("#accordion a[href*='libconverter/classes.html']").last();
		}
		else if (loc.indexOf("libsc_server")>0)
		{
			$element = $("#accordion a[href*='libsc_server/classes.html']").last();
		}
		else if (loc.indexOf("libsc")>0)
		{
			$element = $("#accordion a[href*='libsc/classes.html']").last();
		}
		else if (loc.indexOf("server_cs")>0)
		{
			$element = $("#accordion a[href*='server_cs/classes.html']").last();
		}
		else if (loc.indexOf("server_js")>0)
		{
			$element = $("#accordion a[href*='server_js/modules/communicator.html']").last();
		}
		else if (loc.indexOf("server_java")>0)
		{
			$element = $("#accordion a[href*='server_java/classes.html']").last();
		}
		//if nothing is found, just set it to the last one and hope for the best
		else $element = $element.last();
	}
	
	
	if ($element !==null)
	{
		$element.css("font-weight","bold");
		$element.css("color","#0067a3");

		show_accordion($element);
		
		$element.focus();
	}

	$('.api-toggle').click(function(e) {
		//Handle the +/- button image clicks
		var divId = e.target.id.substring(0, e.target.id.length - '_link'.length + 1);
		
		document.getElementById(divId).style.display = (document.getElementById(divId).style.display == 'none') ? 'block' : 'none';	
	
		var imageElement = document.getElementById(divId + "_img");	
		imageElement.src = (imageElement.src.indexOf('plus.gif') >= 0) ? imageElement.src.replace('plus.gif', 'minus.gif') : imageElement.src.replace('minus.gif', 'plus.gif');
	
		e.preventDefault();
	});
  });
  

function constFunc(x) {
	return function () {
		return x;
	}
}  

var i = 0;
function show_accordion($element){
	
	if ($element.css("display") === "none")
	{
		$element.css("display","block") 
		
	}
   
	if ($element.children(0).attr("id")!=null)
	{	
		var my_id = $element.children(0).attr("id");
		if (my_id.indexOf("subs_link")>0)
		{
			var $img = $element.children(0).children("img");
            var $img_src = $img.attr("src");
			if ($img_src.indexOf("images/plus.gif")>=0)
			{
                
				$img.attr("src",$img_src.substring(0,$img_src.indexOf("images/plus.gif")) + "images/minus.gif");
			}
			$element.addClass("default");
			$element.children("a").css("font-weight","bold");
			$element.children("a").css("color","#0067a3");
            $element.children(".accordion-toggle").css("font-weight","bold");
			$element.children(".accordion-toggle").css("color","#0067a3");
		}
	}
	else if ($.trim($element.next().attr("class")) === "accordion-content")
	{
		var $img = $element.prev().find("img");
		if ($img.attr("src") === "images/plus.gif")
		{
			$img.attr("src","images/minus.gif");
		}
		$element.next().addClass("default");
	}
	
	else if ($element.next().prop("tagName"))
	{
		//if the next element is a ul, then display it
		if ($element.next().prop("tagName").toLowerCase()==="ul")
		{
			$element.next().css("display","block")
			var $img = $element.siblings().find("img");
			if ($img.attr("src") === "images/plus.gif")
			{
				$img.attr("src","images/minus.gif");
			}
		}
		
		
	}
	
	

	var $parent = $element.parent();
	
	// traverse up the DOM until we get to the "sidebar" div 
	// adding a MAX count of 50 to prevent against runaway recursion in case of browser errors
	if (i < 50 && $parent.attr("class") !== "sidebar") {
		i++;
		try
		{
			show_accordion($parent);
		}
		catch(error)
		{
			//do nothing
		}
	}
}
$( window ).resize(function() {
	if($( window ).width() < 1450)
	{
		$( "#subsection_container" ).attr("id","subsection_container_inline");
		$( "#subsection" ).attr("id","subsection_inline");
	}
	
	else 
	{
		$( "#subsection_container_inline" ).attr("id","subsection_container");
		$( "#subsection_inline" ).attr("id","subsection");
	}
});